## cpp-netlib 0.11.0

=== CMakeLists.txt ===
#            Copyright (c) Dean Michael Berris 2010.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE_1_0.txt or copy at
#          http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 2.8)
project(CPP-NETLIB)

option( CPP-NETLIB_BUILD_SHARED_LIBS "Build cpp-netlib as shared libraries." OFF )

include(GNUInstallDirs)

# determine install path for CMake config files
if(WIN32 AND NOT CYGWIN)
    set(DEF_INSTALL_CMAKE_DIR CMake)
else()
    set(DEF_INSTALL_CMAKE_DIR lib/CMake/cppnetlib)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")

# Make relative cmake install path absolute (needed later on)
if(NOT IS_ABSOLUTE "${INSTALL_CMAKE_DIR}")
    set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_PREFIX}/${INSTALL_CMAKE_DIR}")
endif()


if(CPP-NETLIB_BUILD_SHARED_LIBS OR BUILD_SHARED_LIBS)
  message (STATUS "Linking boost testing libs dynamically...")
  set(Boost_USE_STATIC_LIBS OFF)
  set(CPP-NETLIB_BUILD_SHARED_LIBS ON)
  set(BUILD_SHARED_LIBS ON)
  add_definitions(-DBOOST_TEST_DYN_LINK)
else()
  set(Boost_USE_STATIC_LIBS ON)
  set(CPP-NETLIB_BUILD_SHARED_LIBS OFF)
  set(BUILD_SHARED_LIBS OFF)
endif()

set(Boost_USE_MULTI_THREADED ON)
find_package( Boost 1.54.0
    REQUIRED unit_test_framework system regex date_time thread filesystem
    program_options chrono atomic )
find_package( OpenSSL )
find_package( Threads )
set(CMAKE_VERBOSE_MAKEFILE true)

set(CPPNETLIB_VERSION_MAJOR 0) # MUST bump this whenever we make ABI-incompatible changes
set(CPPNETLIB_VERSION_MINOR 11)
set(CPPNETLIB_VERSION_PATCH 0)
set(CPPNETLIB_VERSION_STRING ${CPPNETLIB_VERSION_MAJOR}.${CPPNETLIB_VERSION_MINOR}.${CPPNETLIB_VERSION_PATCH})

if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DBOOST_NETWORK_DEBUG)
endif()

if (OPENSSL_FOUND)
    add_definitions(-DBOOST_NETWORK_ENABLE_HTTPS)
    include_directories(${OPENSSL_INCLUDE_DIR})
endif()

if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
elseif (${CMAKE_CXX_COMPILER_ID} MATCHES Clang)
  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    # We want to link in C++11 mode if we're using Clang and on OS X.
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ftemplate-depth=256 -std=c++11 -stdlib=libc++")
  else()
    # We just add the -Wall and a high enough template depth
    # flag for Clang in other systems.
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ftemplate-dempth=256")
  endif()
endif()


if (Boost_FOUND)
    if (MSVC)
      add_definitions(-D_SCL_SECURE_NO_WARNINGS)
    endif(MSVC)
    if (WIN32)
      add_definitions(-D_WIN32_WINNT=0x0501)
    endif(WIN32)
    include_directories(${Boost_INCLUDE_DIRS})
    enable_testing()
    add_subdirectory(libs/network/src)
    add_subdirectory(libs/network/test)
    add_subdirectory(libs/network/experiment)
    if (NOT MSVC)
      add_subdirectory(libs/mime/test)
    endif(NOT MSVC)
    add_subdirectory(libs/network/example)
endif(Boost_FOUND)

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
endif()

enable_testing()

install(DIRECTORY boost DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

###
## Export Targets
# (so cpp-netlib can be easily used by other CMake projects)
# [see http://www.cmake.org/Wiki/CMake/Tutorials/How_to_create_a_ProjectConfig.cmake_file]

# Add all targets to the build-tree export set
export(TARGETS cppnetlib-client-connections cppnetlib-server-parsers cppnetlib-uri
    FILE "${PROJECT_BINARY_DIR}/cppnetlibTargets.cmake")
# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE cppnetlib)
# Create the cppnetlibConfig.cmake and cppnetlibConfigVersion files
file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}"
    "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
# ... for the build tree
set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}")
configure_file(cppnetlibConfig.cmake.in
    "${PROJECT_BINARY_DIR}/cppnetlibConfig.cmake" @ONLY)
# ... for the install tree
set(CONF_INCLUDE_DIRS "\${CPPNETLIB_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(cppnetlibConfig.cmake.in
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cppnetlibConfig.cmake" @ONLY)
# ... for both
configure_file(cppnetlibConfigVersion.cmake.in
    "${PROJECT_BINARY_DIR}/cppnetlibConfigVersion.cmake" @ONLY)
# Install the cppnetlibConfig.cmake and cppnetlibConfigVersion.cmake
install(FILES
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cppnetlibConfig.cmake"
    "${PROJECT_BINARY_DIR}/cppnetlibConfigVersion.cmake"
    DESTINATION "${INSTALL_CMAKE_DIR}"
    COMPONENT dev)
# Install the export set for use with the install-tree
install(EXPORT cppnetlibTargets
    DESTINATION "${INSTALL_CMAKE_DIR}"
    COMPONENT dev)

=== libs/mime/test/CMakeLists.txt ===
include_directories(${CPP-NETLIB_SOURCE_DIR})
file ( COPY TestMessages DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )

#This test causes a "too many sections" error on Windows MinGW64
#(MSVC has /bigobj, MinGW does not)
if (NOT(${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
  if ( Boost_FOUND )
    add_executable ( mime-roundtrip mime-roundtrip.cpp )
    target_link_libraries ( mime-roundtrip ${Boost_LIBRARIES}
      ${CMAKE_THREAD_LIBS_INIT})
    add_test ( mime-roundtrip ${CPP-NETLIB_BINARY_DIR}/tests/mime-roundtrip )
  endif ()
endif()

=== libs/network/example/CMakeLists.txt ===
#            Copyright (c) Dean Michael Berris 2010.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE_1_0.txt or copy at
#          http://www.boost.org/LICENSE_1_0.txt)

include_directories(${CPP-NETLIB_SOURCE_DIR})
if (OPENSSL_FOUND)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif (OPENSSL_FOUND)

add_executable(http_client http_client.cpp)
add_executable(simple_wget simple_wget.cpp)
add_executable(atom_reader atom/atom.cpp atom/main.cpp)
add_executable(rss_reader rss/rss.cpp rss/main.cpp)
add_executable(twitter_search twitter/search.cpp)
add_executable(hello_world_server http/hello_world_server.cpp)
add_executable(hello_world_client http/hello_world_client.cpp)
add_executable(hello_world_async_server_with_work_queue http/hello_world_async_server_with_work_queue.cpp)
if (UNIX)
  add_executable(fileserver http/fileserver.cpp)
endif (UNIX)
add_dependencies(http_client cppnetlib-uri cppnetlib-client-connections)
add_dependencies(simple_wget cppnetlib-uri cppnetlib-client-connections)
add_dependencies(atom_reader cppnetlib-uri cppnetlib-client-connections)
add_dependencies(rss_reader cppnetlib-uri cppnetlib-client-connections)
add_dependencies(twitter_search cppnetlib-uri cppnetlib-client-connections)
set(BOOST_CLIENT_LIBS
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
    ${Boost_THREAD_LIBRARY}
    ${Boost_DATE_TIME_LIBRARY}
    ${Boost_REGEX_LIBRARY}
    ${Boost_SYSTEM_LIBRARY}
    ${Boost_FILESYSTEM_LIBRARY}
    ${Boost_CHRONO_LIBRARY})

set(BOOST_SERVER_LIBS
    ${Boost_THREAD_LIBRARY}
    ${Boost_SYSTEM_LIBRARY}
    ${Boost_DATE_TIME_LIBRARY}
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
    ${Boost_FILESYSTEM_LIBRARY}
    ${Boost_CHRONO_LIBRARY})

target_link_libraries(http_client
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(simple_wget
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(atom_reader
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(rss_reader
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(twitter_search
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(hello_world_server
    ${BOOST_SERVER_LIBS}
    ${CMAKE_THREAD_LIBS_INIT})

target_link_libraries(hello_world_client
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections)

target_link_libraries(hello_world_async_server_with_work_queue
    ${BOOST_CLIENT_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-uri
    cppnetlib-client-connections
    cppnetlib-server-parsers)

if (OPENSSL_FOUND)
  target_link_libraries(http_client ${OPENSSL_LIBRARIES})
  target_link_libraries(simple_wget ${OPENSSL_LIBRARIES})
  target_link_libraries(atom_reader ${OPENSSL_LIBRARIES})
  target_link_libraries(rss_reader ${OPENSSL_LIBRARIES})
  target_link_libraries(twitter_search ${OPENSSL_LIBRARIES})
  target_link_libraries(hello_world_server ${OPENSSL_LIBRARIES})
  target_link_libraries(hello_world_client ${OPENSSL_LIBRARIES})
  target_link_libraries(hello_world_async_server_with_work_queue ${OPENSSL_LIBRARIES})
endif (OPENSSL_FOUND)

if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  target_link_libraries(http_client ws2_32)
  target_link_libraries(simple_wget ws2_32)
  target_link_libraries(atom_reader ws2_32)
  target_link_libraries(rss_reader ws2_32)
  target_link_libraries(twitter_search ws2_32)
  target_link_libraries(hello_world_server ws2_32 wsock32)
  target_link_libraries(hello_world_client ws2_32)
  target_link_libraries(hello_world_async_server_with_work_queue ws2_32 wsock32)
endif()

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  target_link_libraries(http_client rt)
  target_link_libraries(simple_wget rt)
  target_link_libraries(atom_reader rt)
  target_link_libraries(rss_reader rt)
  target_link_libraries(twitter_search rt)
  target_link_libraries(hello_world_server rt)
  target_link_libraries(hello_world_client rt)
  target_link_libraries(hello_world_async_server_with_work_queue rt)
endif()

if (UNIX)
  target_link_libraries(fileserver
    ${BOOST_SERVER_LIBS}
    ${Boost_FILESYSTEM_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    cppnetlib-server-parsers)
  if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(fileserver rt)
  endif()
endif (UNIX)

set_target_properties(http_client PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(simple_wget PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(atom_reader PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(rss_reader PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(twitter_search PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(hello_world_server PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(hello_world_client PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
set_target_properties(hello_world_async_server_with_work_queue PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
if (UNIX)
  set_target_properties(fileserver PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
endif (UNIX)

=== libs/network/experiment/CMakeLists.txt ===
# Copyright 2013 Google, Inc.
# Copyright 2010 Dean Michael Berris <dberris@google.com>
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# Commenting this out until it's ready for prime-time later on.
# include_directories(${CPP-NETLIB_SOURCE_DIR})
# set(CMAKE_BUILD_TYPE Release)
# if (Boost_FOUND)
#   add_executable(cpp-netlib-utils_base64_experiment utils_base64_experiment.cpp)
#   target_link_libraries(cpp-netlib-utils_base64_experiment ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
#   if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
#     target_link_libraries(cpp-netlib-utils_base64_experiment rt)
#   endif()
#   set_target_properties(cpp-netlib-utils_base64_experiment
#                         PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
# endif()

=== libs/network/src/CMakeLists.txt ===
# Copyright (c) Glyn Matthews 2011.
# Copyright 2011 Dean Michael Berris (dberris@google.com)
# Copyright 2011 Google, Inc.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE_1_0.txt or copy at
#          http://www.boost.org/LICENSE_1_0.txt)


include_directories(${CPP-NETLIB_SOURCE_DIR})

file(GLOB_RECURSE CPP-NETLIB_HEADERS 
    "${CPP-NETLIB_SOURCE_DIR}/boost/" "*.hpp")

set(CPP-NETLIB_URI_SRCS uri/uri.cpp uri/schemes.cpp)
add_library(cppnetlib-uri ${CPP-NETLIB_URI_SRCS})
set_target_properties(cppnetlib-uri
    PROPERTIES VERSION ${CPPNETLIB_VERSION_STRING}
    SOVERSION ${CPPNETLIB_VERSION_MAJOR}
    PUBLIC_HEADER "${CPP-NETLIB_HEADERS}")
install(TARGETS cppnetlib-uri
    EXPORT cppnetlibTargets
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

set(CPP-NETLIB_HTTP_SERVER_SRCS server_request_parsers_impl.cpp)
add_library(cppnetlib-server-parsers ${CPP-NETLIB_HTTP_SERVER_SRCS})
set_target_properties(cppnetlib-server-parsers
    PROPERTIES VERSION ${CPPNETLIB_VERSION_STRING}
    SOVERSION ${CPPNETLIB_VERSION_MAJOR}
    PUBLIC_HEADER "${CPP-NETLIB_HEADERS}")
install(TARGETS cppnetlib-server-parsers
    EXPORT cppnetlibTargets
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

set(CPP-NETLIB_HTTP_CLIENT_SRCS client.cpp)
add_library(cppnetlib-client-connections ${CPP-NETLIB_HTTP_CLIENT_SRCS})
set_target_properties(cppnetlib-client-connections
    PROPERTIES VERSION ${CPPNETLIB_VERSION_STRING}
    SOVERSION ${CPPNETLIB_VERSION_MAJOR}
    PUBLIC_HEADER "${CPP-NETLIB_HEADERS}")
if (OPENSSL_FOUND)
    target_link_libraries(cppnetlib-client-connections ${OPENSSL_LIBRARIES})
endif ()
if (Boost_FOUND)
    target_link_libraries(cppnetlib-client-connections ${Boost_System_LIBRARY})
endif ()
install(TARGETS cppnetlib-client-connections
    EXPORT cppnetlibTargets
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

=== libs/network/test/CMakeLists.txt ===
#            Copyright (c) Dean Michael Berris 2010.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE_1_0.txt or copy at
#          http://www.boost.org/LICENSE_1_0.txt)

include_directories(${CPP-NETLIB_SOURCE_DIR})

add_subdirectory(uri)
add_subdirectory(http)

if (Boost_FOUND)
    set(
        TESTS
        message_test
        message_transform_test
        utils_thread_pool
	# utils_base64_test -- turn on when ready.
        )
    foreach (test ${TESTS})
        if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
          set_source_files_properties(${test}.cpp
            PROPERTIES COMPILE_FLAGS "-Wall")
        endif()
        add_executable(cpp-netlib-${test} ${test}.cpp)
	    add_dependencies(cpp-netlib-${test} cppnetlib-uri)
        target_link_libraries(cpp-netlib-${test} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} cppnetlib-uri)
        if (OPENSSL_FOUND)
          target_link_libraries(cpp-netlib-${test} ${OPENSSL_LIBRARIES})
        endif()
        if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
		  target_link_libraries(cpp-netlib-${test} ws2_32 wsock32)
		endif()
	    if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	      target_link_libraries(cpp-netlib-${test} rt)
	    endif()
        set_target_properties(cpp-netlib-${test}
            PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
        add_test(cpp-netlib-${test}
            ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-${test})
    endforeach (test)

endif()

=== libs/network/test/http/CMakeLists.txt ===

# Copyright 2010 Dean Michael Berris.
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

include_directories(${CPP-NETLIB_SOURCE_DIR})

if (OPENSSL_FOUND)
    include_directories( ${OPENSSL_INCLUDE_DIR} )
    add_definitions(-DBOOST_NETWORK_ENABLE_HTTPS)
endif()

if (Boost_FOUND)
    set ( TESTS
        request_incremental_parser_test
	      request_linearize_test
        )
    foreach ( test ${TESTS} )
        add_executable(cpp-netlib-http-${test} ${test}.cpp)
        add_dependencies(cpp-netlib-http-${test}
            cppnetlib-uri)
        target_link_libraries(cpp-netlib-http-${test}
            ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT}
            cppnetlib-uri)
	    if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
          target_link_libraries(cpp-netlib-http-${test} ws2_32)
        endif()
	    if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	      target_link_libraries(cpp-netlib-http-${test} rt)
	    endif()
        set_target_properties(cpp-netlib-http-${test}
            PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
        add_test(cpp-netlib-http-${test}
            ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-http-${test})
    endforeach (test)
    set ( TESTS
        client_constructor_test
        client_get_test
        client_get_different_port_test
        client_get_timeout_test
        client_get_streaming_test
        )
    foreach ( test ${TESTS} )
        add_executable(cpp-netlib-http-${test} ${test}.cpp)
        add_dependencies(cpp-netlib-http-${test}
            cppnetlib-uri
            cppnetlib-client-connections)
        target_link_libraries(cpp-netlib-http-${test}
            ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT}
            cppnetlib-uri
            cppnetlib-client-connections)
        if (OPENSSL_FOUND)
            target_link_libraries(cpp-netlib-http-${test} ${OPENSSL_LIBRARIES})
        endif()
	      if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
          target_link_libraries(cpp-netlib-http-${test} ws2_32)
        endif()
	      if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	        target_link_libraries(cpp-netlib-http-${test} rt)
	      endif()
        set_target_properties(cpp-netlib-http-${test}
            PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
        add_test(cpp-netlib-http-${test}
            ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-http-${test})
    endforeach (test)

    set ( SERVER_API_TESTS
        server_constructor_test
        server_async_run_stop_concurrency
        server_header_parser_test
        )
    foreach ( test ${SERVER_API_TESTS} )
        add_executable(cpp-netlib-http-${test} ${test}.cpp)
        add_dependencies(cpp-netlib-http-${test} cppnetlib-server-parsers)
        target_link_libraries(cpp-netlib-http-${test} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} cppnetlib-server-parsers)
	      if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
          target_link_libraries(cpp-netlib-http-${test} ws2_32 wsock32)
        endif()
	      if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	        target_link_libraries(cpp-netlib-http-${test} rt)
	      endif()
        set_target_properties(cpp-netlib-http-${test}
            PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
        add_test(cpp-netlib-http-${test}
            ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-http-${test})
    endforeach (test)

endif()

=== libs/network/test/uri/CMakeLists.txt ===
#            Copyright (c) Dean Michael Berris 2010.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE_1_0.txt or copy at
#          http://www.boost.org/LICENSE_1_0.txt)

include_directories(${CPP-NETLIB_SOURCE_DIR})

if (Boost_FOUND)
    set(
        TESTS
        uri_test
        uri_builder_test
        uri_builder_stream_test
        uri_encoding_test
        relative_uri_test
        )
    foreach (test ${TESTS})
        if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
          set_source_files_properties(${test}.cpp
            PROPERTIES COMPILE_FLAGS "-Wall")
        endif()
        add_executable(cpp-netlib-${test} ${test}.cpp)
        add_dependencies(cpp-netlib-${test} cppnetlib-uri)
        target_link_libraries(cpp-netlib-${test}
            ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} cppnetlib-uri)
        if (OPENSSL_FOUND)
          target_link_libraries(cpp-netlib-${test} ${OPENSSL_LIBRARIES})
        endif()
        if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
		  target_link_libraries(cpp-netlib-${test} ws2_32)
		endif()
        set_target_properties(cpp-netlib-${test}
            PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
        add_test(cpp-netlib-${test}
            ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-${test})
    endforeach (test)

endif()

=== debian/changelog ===
cpp-netlib (0.11.0-1) unstable; urgency=low

  * New upstream release.
  * Update to latest Standards-Version.
  * Disable tests that require an internet connection. (Closes: #731011)

 -- Ximin Luo <infinity0@pwned.gg>  Sun, 09 Feb 2014 16:01:56 +0000

cpp-netlib (0.10.1-1) unstable; urgency=low

  * Initial release (Closes: #727212)

 -- Ximin Luo <infinity0@gmx.com>  Sun, 27 Oct 2013 14:22:08 +0000

=== debian/control ===
Source: cpp-netlib
Priority: extra
Maintainer: Ximin Luo <infinity0@pwned.gg>
Build-Depends: debhelper (>= 9), cmake,
 libboost-test-dev (>= 1.54),
 libboost-system-dev (>= 1.54),
 libboost-regex-dev (>= 1.54),
 libboost-date-time-dev (>= 1.54),
 libboost-thread-dev (>= 1.54),
 libboost-filesystem-dev (>= 1.54),
 libboost-program-options-dev (>= 1.54),
 libboost-chrono-dev (>= 1.54),
 libssl-dev
Build-Depends-Indep: python-sphinx
Standards-Version: 3.9.5
Section: libs
Homepage: http://cpp-netlib.org/
Vcs-Git: git://anonscm.debian.org/users/infinity0-guest/cpp-netlib.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/infinity0-guest/cpp-netlib.git

Package: libcppnetlib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libcppnetlib0 (= ${binary:Version}),
 libboost-system-dev,
 libboost-regex-dev,
 libboost-date-time-dev,
 libboost-thread-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-chrono-dev,
 libssl-dev
Suggests: libcppnetlib-doc
Description: C++ Network Library - development files
 The C++ Network Library Project aims to build upon the latest C++ standard
 (currently C++11) to provide easy to use libraries for network programming. We
 use the latest compiler versions and features with an eye on pushing the
 boundaries on leveraging what's available in C++.
 .
 Currently the library contains an HTTP client and server implementation, a
 stand-alone URI library, a network message framework, and some concurrency
 tools.
 .
 This package provides the development files (ie. includes, static library,
 manual pages) that allow to build software which uses libcppnetlib.

Package: libcppnetlib0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Network Library
 The C++ Network Library Project aims to build upon the latest C++ standard
 (currently C++11) to provide easy to use libraries for network programming. We
 use the latest compiler versions and features with an eye on pushing the
 boundaries on leveraging what's available in C++.
 .
 Currently the library contains an HTTP client and server implementation, a
 stand-alone URI library, a network message framework, and some concurrency
 tools.
 .
 This package provides the shared libraries needed to run programs using
 libcppnetlib.

Package: libcppnetlib-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-sphinxdoc
Description: C++ Network Library - documentation
 The C++ Network Library Project aims to build upon the latest C++ standard
 (currently C++11) to provide easy to use libraries for network programming. We
 use the latest compiler versions and features with an eye on pushing the
 boundaries on leveraging what's available in C++.
 .
 Currently the library contains an HTTP client and server implementation, a
 stand-alone URI library, a network message framework, and some concurrency
 tools.
 .
 This package provides additional documentation, including a tutorial, example
 code, and API reference.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- -DCPP-NETLIB_BUILD_SHARED_LIBS:BOOL=ON

override_dh_auto_configure-indep:

override_dh_auto_build-indep:
	cd libs/network/doc && $(MAKE) html

override_dh_auto_test-indep:

override_dh_auto_clean:
	cd libs/network/doc && $(MAKE) clean
	dh_auto_clean

override_dh_compress:
	dh_compress -X /examples/

=== debian/watch ===
version=3
http://cpp-netlib.org/ http://commondatastorage.googleapis.com/cpp-netlib-downloads/(?:\d.*)/cpp-netlib-(.*)\.tar\.gz

## cpp-netlib 0.11.1%2bdfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,8 @@
 project(CPP-NETLIB)
 
 option( CPP-NETLIB_BUILD_SHARED_LIBS "Build cpp-netlib as shared libraries." OFF )
+option( CPP-NETLIB_BUILD_TESTS "Build the cpp-netlib project tests." ON)
+option( CPP-NETLIB_BUILD_EXAMPLES "Build the cpp-netlib project examples." ON)
 
 include(GNUInstallDirs)
 
@@ -14,7 +16,7 @@
 if(WIN32 AND NOT CYGWIN)
     set(DEF_INSTALL_CMAKE_DIR CMake)
 else()
-    set(DEF_INSTALL_CMAKE_DIR lib/CMake/cppnetlib)
+    set(DEF_INSTALL_CMAKE_DIR lib/cmake/cppnetlib)
 endif()
 set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")
 
@@ -67,7 +69,7 @@
   else()
     # We just add the -Wall and a high enough template depth
     # flag for Clang in other systems.
-    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ftemplate-dempth=256")
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ftemplate-depth=256")
   endif()
 endif()
 
@@ -82,12 +84,16 @@
     include_directories(${Boost_INCLUDE_DIRS})
     enable_testing()
     add_subdirectory(libs/network/src)
-    add_subdirectory(libs/network/test)
+    if (CPP-NETLIB_BUILD_TESTS)
+      add_subdirectory(libs/network/test)
+    endif (CPP-NETLIB_BUILD_TESTS)
     add_subdirectory(libs/network/experiment)
-    if (NOT MSVC)
+    if (NOT MSVC AND CPP-NETLIB_BUILD_TESTS)
       add_subdirectory(libs/mime/test)
-    endif(NOT MSVC)
-    add_subdirectory(libs/network/example)
+    endif(NOT MSVC AND CPP-NETLIB_BUILD_TESTS)
+    if (CPP-NETLIB_BUILD_EXAMPLES)
+      add_subdirectory(libs/network/example)
+    endif (CPP-NETLIB_BUILD_EXAMPLES)
 endif(Boost_FOUND)
 
 if (MSVC)

## cpp-netlib 0.11.1+dfsg1

=== debian/changelog ===
cpp-netlib (0.11.1+dfsg1-4) unstable; urgency=low

  * Disable another failing connectivity test.

 -- Ximin Luo <infinity0@pwned.gg>  Thu, 18 Jun 2015 16:22:48 +0200

cpp-netlib (0.11.1+dfsg1-3) unstable; urgency=medium

  * Build documentation reproducibly.

 -- Ximin Luo <infinity0@pwned.gg>  Wed, 17 Jun 2015 19:39:03 +0200

cpp-netlib (0.11.1+dfsg1-2) unstable; urgency=medium

  * Install cmake project files in arch-dependent directories. (Closes: #773603)

 -- Ximin Luo <infinity0@pwned.gg>  Mon, 22 Dec 2014 01:12:05 +0100

cpp-netlib (0.11.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Install cmake package configuration files. (Closes: #760351)
  * Update to latest Standards-Version. No changes required.

 -- Ximin Luo <infinity0@pwned.gg>  Fri, 19 Dec 2014 22:03:13 +0100

cpp-netlib (0.11.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use ggc-min-expand=20 to build on mips/mipsel.
    Patch by Dejan Latinovic.
    Closes: #754258.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 15 Jul 2014 11:36:59 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libboost-chrono-dev (>= 1.54),
  libssl-dev
 Build-Depends-Indep: python-sphinx
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://cpp-netlib.org/
 Vcs-Git: git://anonscm.debian.org/users/infinity0-guest/cpp-netlib.git
@@ -43,7 +43,7 @@
  tools.
  .
  This package provides the development files (ie. includes, static library,
- manual pages) that allow to build software which uses libcppnetlib.
+ manual pages) that allow one to build software which uses libcppnetlib.
 
 Package: libcppnetlib0
 Architecture: any

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
http://cpp-netlib.org/ http://storage.googleapis.com/cpp-netlib-downloads/(?:\d.*)/cpp-netlib-(.*?)(?:-final)?\.tar\.gz

## cpp-netlib 0.11.2+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,9 @@
 
 option( CPP-NETLIB_BUILD_SHARED_LIBS "Build cpp-netlib as shared libraries." OFF )
 option( CPP-NETLIB_BUILD_TESTS "Build the cpp-netlib project tests." ON)
+option( CPP-NETLIB_BUILD_EXPERIMENTS "Build the cpp-netlib project experiments." ON)
 option( CPP-NETLIB_BUILD_EXAMPLES "Build the cpp-netlib project examples." ON)
+option( CPP-NETLIB_ENABLE_HTTPS "Build cpp-netlib with support for https if OpenSSL is found." ON)
 
 include(GNUInstallDirs)
 
@@ -16,7 +18,7 @@
 if(WIN32 AND NOT CYGWIN)
     set(DEF_INSTALL_CMAKE_DIR CMake)
 else()
-    set(DEF_INSTALL_CMAKE_DIR lib/cmake/cppnetlib)
+    set(DEF_INSTALL_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/cppnetlib)
 endif()
 set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")
 
@@ -42,13 +44,17 @@
 find_package( Boost 1.54.0
     REQUIRED unit_test_framework system regex date_time thread filesystem
     program_options chrono atomic )
-find_package( OpenSSL )
+
+if (CPP-NETLIB_ENABLE_HTTPS)
+    find_package( OpenSSL )
+endif()
+
 find_package( Threads )
 set(CMAKE_VERBOSE_MAKEFILE true)
 
 set(CPPNETLIB_VERSION_MAJOR 0) # MUST bump this whenever we make ABI-incompatible changes
 set(CPPNETLIB_VERSION_MINOR 11)
-set(CPPNETLIB_VERSION_PATCH 0)
+set(CPPNETLIB_VERSION_PATCH 1)
 set(CPPNETLIB_VERSION_STRING ${CPPNETLIB_VERSION_MAJOR}.${CPPNETLIB_VERSION_MINOR}.${CPPNETLIB_VERSION_PATCH})
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
@@ -87,7 +93,9 @@
     if (CPP-NETLIB_BUILD_TESTS)
       add_subdirectory(libs/network/test)
     endif (CPP-NETLIB_BUILD_TESTS)
-    add_subdirectory(libs/network/experiment)
+    if (CPP-NETLIB_BUILD_EXPERIMENTS)
+      add_subdirectory(libs/network/experiment)
+    endif (CPP-NETLIB_BUILD_EXPERIMENTS)
     if (NOT MSVC AND CPP-NETLIB_BUILD_TESTS)
       add_subdirectory(libs/mime/test)
     endif(NOT MSVC AND CPP-NETLIB_BUILD_TESTS)
@@ -119,11 +127,12 @@
 file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}"
     "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
 # ... for the build tree
-set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}")
+set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}" ${Boost_INCLUDE_DIRS})
 configure_file(cppnetlibConfig.cmake.in
     "${PROJECT_BINARY_DIR}/cppnetlibConfig.cmake" @ONLY)
 # ... for the install tree
 set(CONF_INCLUDE_DIRS "\${CPPNETLIB_CMAKE_DIR}/${REL_INCLUDE_DIR}")
+set(CONF_INCLUDE_DIRS ${CONF_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})
 configure_file(cppnetlibConfig.cmake.in
     "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cppnetlibConfig.cmake" @ONLY)
 # ... for both

=== libs/mime/test/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,8 @@
     add_executable ( mime-roundtrip mime-roundtrip.cpp )
     target_link_libraries ( mime-roundtrip ${Boost_LIBRARIES}
       ${CMAKE_THREAD_LIBS_INIT})
+    set_target_properties( mime-roundtrip
+        PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/tests)
     add_test ( mime-roundtrip ${CPP-NETLIB_BINARY_DIR}/tests/mime-roundtrip )
   endif ()
 endif()

=== libs/network/build/CMakeLists.txt ===
include_directories(${CPP-NETLIB_SOURCE_DIR})
find_package( Boost 1.45.0 COMPONENTS unit_test_framework system regex thread filesystem )

add_library(cppnetlib-uri STATIC ${CPP-NETLIB_SOURCE_DIR}/libs/network/src/parse_uri_impl.cpp)
add_library(cppnetlib-server-parsers STATIC ${CPP-NETLIB_SOURCE_DIR}/libs/network/src/server_request_parsers_impl.cpp)

=== libs/network/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/cpp-netlib.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/cpp-netlib.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== libs/network/example/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 add_executable(hello_world_server http/hello_world_server.cpp)
 add_executable(hello_world_client http/hello_world_client.cpp)
 add_executable(hello_world_async_server_with_work_queue http/hello_world_async_server_with_work_queue.cpp)
+add_executable(trivial_google trivial_google.cpp)
 if (UNIX)
   add_executable(fileserver http/fileserver.cpp)
 endif (UNIX)
@@ -24,6 +25,7 @@
 add_dependencies(atom_reader cppnetlib-uri cppnetlib-client-connections)
 add_dependencies(rss_reader cppnetlib-uri cppnetlib-client-connections)
 add_dependencies(twitter_search cppnetlib-uri cppnetlib-client-connections)
+add_dependencies(trivial_google cppnetlib-uri cppnetlib-client-connections)
 set(BOOST_CLIENT_LIBS
     ${Boost_PROGRAM_OPTIONS_LIBRARY}
     ${Boost_THREAD_LIBRARY}
@@ -37,6 +39,7 @@
     ${Boost_THREAD_LIBRARY}
     ${Boost_SYSTEM_LIBRARY}
     ${Boost_DATE_TIME_LIBRARY}
+    ${Boost_REGEX_LIBRARY}
     ${Boost_PROGRAM_OPTIONS_LIBRARY}
     ${Boost_FILESYSTEM_LIBRARY}
     ${Boost_CHRONO_LIBRARY})
@@ -71,6 +74,12 @@
     cppnetlib-uri
     cppnetlib-client-connections)
 
+target_link_libraries(trivial_google
+  ${BOOST_CLIENT_LIBS}
+  ${CMAKE_THREAD_LIBS_INIT}
+  cppnetlib-uri
+  cppnetlib-client-connections)
+
 target_link_libraries(hello_world_server
     ${BOOST_SERVER_LIBS}
     ${CMAKE_THREAD_LIBS_INIT})
@@ -97,6 +106,7 @@
   target_link_libraries(hello_world_server ${OPENSSL_LIBRARIES})
   target_link_libraries(hello_world_client ${OPENSSL_LIBRARIES})
   target_link_libraries(hello_world_async_server_with_work_queue ${OPENSSL_LIBRARIES})
+  target_link_libraries(trivial_google ${OPENSSL_LIBRARIES})
 endif (OPENSSL_FOUND)
 
 if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
@@ -108,6 +118,7 @@
   target_link_libraries(hello_world_server ws2_32 wsock32)
   target_link_libraries(hello_world_client ws2_32)
   target_link_libraries(hello_world_async_server_with_work_queue ws2_32 wsock32)
+  target_link_libraries(trivial_google ws2_32)
 endif()
 
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
@@ -119,6 +130,7 @@
   target_link_libraries(hello_world_server rt)
   target_link_libraries(hello_world_client rt)
   target_link_libraries(hello_world_async_server_with_work_queue rt)
+  target_link_libraries(trivial_google rt)
 endif()
 
 if (UNIX)
@@ -130,6 +142,9 @@
   if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     target_link_libraries(fileserver rt)
   endif()
+  if (OPENSSL_FOUND)
+    target_link_libraries(fileserver ${OPENSSL_LIBRARIES})
+  endif(OPENSSL_FOUND)
 endif (UNIX)
 
 set_target_properties(http_client PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
@@ -137,9 +152,11 @@
 set_target_properties(atom_reader PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 set_target_properties(rss_reader PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 set_target_properties(twitter_search PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
+set_target_properties(trivial_google PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 set_target_properties(hello_world_server PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 set_target_properties(hello_world_client PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 set_target_properties(hello_world_async_server_with_work_queue PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
+
 if (UNIX)
   set_target_properties(fileserver PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CPP-NETLIB_BINARY_DIR}/example)
 endif (UNIX)

=== libs/network/src/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 include_directories(${CPP-NETLIB_SOURCE_DIR})
 
-file(GLOB_RECURSE CPP-NETLIB_HEADERS 
+file(GLOB_RECURSE CPP-NETLIB_HEADERS
     "${CPP-NETLIB_SOURCE_DIR}/boost/" "*.hpp")
 
 set(CPP-NETLIB_URI_SRCS uri/uri.cpp uri/schemes.cpp)
@@ -45,7 +45,7 @@
     target_link_libraries(cppnetlib-client-connections ${OPENSSL_LIBRARIES})
 endif ()
 if (Boost_FOUND)
-    target_link_libraries(cppnetlib-client-connections ${Boost_System_LIBRARY})
+    target_link_libraries(cppnetlib-client-connections ${Boost_LIBRARIES})
 endif ()
 install(TARGETS cppnetlib-client-connections
     EXPORT cppnetlibTargets

=== libs/network/test/CMakeLists.txt ===
--- 
+++ 
@@ -39,5 +39,8 @@
             ${CPP-NETLIB_BINARY_DIR}/tests/cpp-netlib-${test})
     endforeach (test)
 
+    # Also copy the server directory to the root of the build directory.
+    file(COPY server DESTINATION ${CPP-NETLIB_BINARY_DIR}/libs/network/test/)
+
 endif()

=== libs/network/test/http/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 
 if (Boost_FOUND)
     set ( TESTS
+        response_incremental_parser_test
         request_incremental_parser_test
 	      request_linearize_test
         )
@@ -74,6 +75,9 @@
         add_executable(cpp-netlib-http-${test} ${test}.cpp)
         add_dependencies(cpp-netlib-http-${test} cppnetlib-server-parsers)
         target_link_libraries(cpp-netlib-http-${test} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} cppnetlib-server-parsers)
+        if (OPENSSL_FOUND)
+            target_link_libraries(cpp-netlib-http-${test} ${OPENSSL_LIBRARIES})
+        endif()
 	      if (${CMAKE_CXX_COMPILER_ID} MATCHES GNU AND ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
           target_link_libraries(cpp-netlib-http-${test} ws2_32 wsock32)
         endif()

=== debian/changelog ===
cpp-netlib (0.11.2+dfsg1-2) unstable; urgency=medium

  * Fix test failures, by including a new missing dependency.

 -- Ximin Luo <infinity0@debian.org>  Thu, 03 Sep 2015 03:24:24 +0200

cpp-netlib (0.11.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Wed, 02 Sep 2015 16:36:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: cpp-netlib
 Priority: extra
-Maintainer: Ximin Luo <infinity0@pwned.gg>
+Maintainer: Ximin Luo <infinity0@debian.org>
 Build-Depends: debhelper (>= 9), cmake,
  libboost-test-dev (>= 1.54),
  libboost-system-dev (>= 1.54),
@@ -10,13 +10,15 @@
  libboost-filesystem-dev (>= 1.54),
  libboost-program-options-dev (>= 1.54),
  libboost-chrono-dev (>= 1.54),
- libssl-dev
+ libssl-dev,
+# needed for tests
+ python
 Build-Depends-Indep: python-sphinx
 Standards-Version: 3.9.6
 Section: libs
 Homepage: http://cpp-netlib.org/
-Vcs-Git: git://anonscm.debian.org/users/infinity0-guest/cpp-netlib.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/infinity0-guest/cpp-netlib.git
+Vcs-Git: https://anonscm.debian.org/git/users/infinity0/cpp-netlib.git
+Vcs-Browser: https://anonscm.debian.org/cgit/users/infinity0/cpp-netlib.git
 
 Package: libcppnetlib-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,15 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# reproducible documentation
+export SOURCE_DATE_EPOCH := $(shell debian/strip-nondeterminism/dpkg-sourcedate)
+
+DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
+ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=20
+endif
 
 %:
 	dh $@

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
http://cpp-netlib.org/ http://downloads.cpp-netlib.org/(?:\d.*)/cpp-netlib-(.*?)(?:-final)?\.tar\.gz
